<?php
function index(){
?>
	<!DOCTYPE html>
	<html lang="fr">
	<head>
		<title>Recherche une occurence</title>
		<style>
			a { color:#E8E8E8; text-decoration:none; }
			div{ width:500px; background-color:#E8E8E8; padding:10px; margin:10px auto; text-align:justify; position:relative; }
			h1{ margin:0 0 40px 0; text-align:center; font-size:18px; text-transform:uppercase; }
			h2{ margin:40px 0; text-align:center; font-size:16px; text-transform:uppercase; }
			label{ display:inline-block; width:175px; }
			.center{ text-align:center }
			.copy{ position:absolute; height:500px; top:1px; right:-46px; color:#E8E8E8; font-family:Impact; font-size:44px; letter-spacing: 1px; writing-mode:vertical-rl; text-orientation: sideways; }
		    #holiday-overlay{
		    	display:none;
		        position:fixed;
		        top:0; left:0; right:0; bottom:0;
		        background: rgba(0,0,0,0.7);
		        z-index:9999;
		        width:100%;
		    }
		    #holiday-message{
		        width:75%;
		        max-height:75%;
		        padding:30px;
		        background-color: #FFF;
		        top:8%;
		        margin:auto; /*half of width*/
		        border-radius:5px;
		        color:#000;
		        position:relative;
		        overflow-y: auto;
		        overflow-x: hidden;
		        position: relative;
		        white-space: pre-line;
		        font-size: 12px;
		    }
		    .holiday-close{
		       	padding: 5px 2px 2px 2px;
			    position: sticky;
			    top: -10px;
			    cursor: pointer;
			    font-weight: bold;
			    color: #FFF;
			    border-radius: 50px;
			    background: #888;
			    width: 20px;
			    height: 18px;
			    text-align: center;
			    float: right;
		    }
		</style>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
	</head>
	<body>
		<div>
			<h1>Recherche une occurence dans des fichiers</h1>
			<span class="copy"><a href="http://xpert-web.be" target="_blank">XPERT-WEB.BE</a></span>
			<form method="post" action="listfiles.php">
				<p>
					<label>Dossier &agrave; scanner:</label>
					<input type="text" name="dossier" value="<?php echo $_REQUEST['dossier']; ?>" />
					&nbsp;R&eacute;cursif:
					<select name="recursif">
						<option value="1" <?php if($_REQUEST['recursif'] == 1) echo 'selected="selected"'; ?>>Oui</option>
						<option value="0" <?php if($_REQUEST['recursif'] == 0) echo 'selected="selected"'; ?>>Non</option>
					</select>
				</p>
				<p>
					<label>Extension(s) &agrave; v&eacute;rifier:</label>
					<input type="text" name="extensions" value="<?php echo $_REQUEST['extensions']; ?>" /> <small>(s&eacute;par&eacute;es par une virgule)</small>
				</p>
				<p>
					<label>Terme(s) &agrave; trouver:</label>
					<input type="text" name="occure" value="<?php echo $_REQUEST['occure']; ?>" />
					&nbsp;Casse ?
					<input type="checkbox" name="casse" <?php if(isset($_REQUEST['casse']) AND !empty($_REQUEST['casse'])) echo 'checked="checked"'; ?>" />
				</p>
				<p class="center">
					<input type="submit" />
				</p>
			</form>
		</div>
		<div>
			<?php if(!empty($_POST) AND !empty($_POST['extensions']) AND !empty($_POST['occure'])) 
			{		
				$realpath = dirname(__FILE__);
				$folder = (!empty($_REQUEST['dossier'])) ?  $_REQUEST['dossier'] : '.';
				$extensions = explode(',', $_REQUEST['extensions']);
				$recursif = ($_REQUEST['recursif'] == 1) ?  true : false;

				$ext = str_replace(' ', '', $extensions);

				foreach ($ext as $key => $value) {
					$filesArray = getAllFiles($folder, $ext, $recursif);
				}	
				
				$count = 0;
				$listOfFiles = fopen('listfiles.txt', 'w+');
				
				foreach($filesArray AS $cle => $valeur)
				{
					if($folder == '.') $valeur = substr($valeur, 2);
					$line = $realpath . "/" . $valeur . "\r\n";
					fputs($listOfFiles, $line);
					$count++;
				}
				fclose($listOfFiles); 

				if(isset($_REQUEST['casse']) AND !empty($_REQUEST['casse']))
				{
					$findWhat = addslashes($_REQUEST['occure']);
					$casse = '&casse=1';
				}
				else {
					$findWhat = addslashes(strtolower($_REQUEST['occure']));
					$casse = '&casse=0';
				} 

				echo '<p class="center">La recherche va porter sur <b>' . $count . '</b> fichiers ! Continuer ?</p>';
				echo '<p class="center"><input type="button" value="Oui" id="envoyer" /> <input type="button" value="non" onclick="window.location.href=\'listfiles.php\'" /></p>';
			}
			?>
		</div>
	
		<div id="holiday-overlay">
			<div id="holiday-message"></div>
		</div>
		
		<div>
			<small>Soyez certain d'avoir bien mis les droits en lecture et en écriture (CHMOD 777) sur le fichier <strong>listfiles_log.txt</strong> et de ne pas avoir de restrictions sur l'accès directs aux fichiers de type <strong>txt</strong> (dans le fichier .htaccess).</small>
		</div>
	</body>
	</html>
	<script>
		function closeDiv() {
			$('#holiday-message').empty();
			$('#holiday-overlay').hide();
    	}

		$('#envoyer').click(function(){

			var findWhat = $('input[name=\'occure\']').val();
			var casse = $('input[name=\'casse\']').is(':checked');
     
		    $.ajax({
				url : 'listfiles.php?op=cleanFiles',
				type : 'POST', 
				data : 'find=' + findWhat + '&casse=' + casse, 
				dataType : 'html',
			    beforeSend: function() {
			        // setting a timeout
						$('#holiday-overlay').show();
					  	$('#holiday-message').append('<h2>Chargement en cours...<br>Merci de bien vouloir patienter !</h2>');
			    },
				success: function(data) {

					$('#holiday-message').html('<a class="holiday-close" onclick="closeDiv();">&times;</a>');

					$.get('listfiles_log.txt', function( donnees ) {
						
					  	$('#holiday-message').append(donnees);
					});
					
				},
				error: function(xhr, ajaxOptions, thrownError) {
					alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
				}

	    	});
	    });
	</script>

<?php
}
function getAllFiles($folder, $ext, $recursif = true) {
 
	$files = array();
	$dir = opendir($folder);
	while ($file = readdir($dir)) 
	{
		if ($file == '.'  OR $file == '..') continue;
		if (is_dir($folder . '/' . $file)) 
		{
			if ($recursif == true) $files = array_merge($files, getAllFiles($folder . '/' . $file, $ext));
		}
		else
		{
			foreach ($ext as $v) {
				if (strtolower($v) == strtolower(substr($file,-strlen($v)))) 
				{
					$files[] = $folder . '/' . $file;
					break;
				}
			}
		}
	}
	closedir($dir);
	return $files;
}

function cleanFiles($findWhat, $casse){
	$listOfFiles = "listfiles.txt";
	$occurCounter = 0;	
	$cleanLog = fopen('listfiles_log.txt', 'w+');
	$thisFileList = fopen($listOfFiles, 'r');

	if ($thisFileList !== FALSE) {
		while ($file = rtrim(fgets($thisFileList))) {
			$possibleFiles = fopen($file, 'r');
	   		$lncount = 0;
			if ($possibleFiles !== FALSE) {
				while ($lineToCheck = fgets($possibleFiles)) {
      				$lncount++;
					if($casse === true) {
						if (strpos($lineToCheck, $findWhat) !== FALSE) {
							$occurCounter++;
							fwrite($cleanLog,  "Occurence dans " . $file . " (ligne " . $lncount . ")\n");							
						}
					}
					else {
						if (stripos($lineToCheck, $findWhat) !== FALSE) {
							$occurCounter++;
							fwrite($cleanLog,  "Occurence dans " . $file . " (ligne " . $lncount . ")\n");							
						}
					}
				}
				fclose($possibleFiles);
			}
			else {}
		}
		fwrite($cleanLog, "\nNombre d'occurence(s) : " . $occurCounter);
		fclose($cleanLog);
		fclose($thisFileList);
	}
	@chmod ('listfiles_log.txt', 0777); 
	//header('Location: listfiles_log.txt');
}
	error_reporting(0);
	
	switch ($_REQUEST['op'])
	{
		case "cleanFiles":
		cleanFiles($_REQUEST['find'], $_REQUEST['casse']);
		break;

		default:
		index();
		break;
	}
?>